// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from autoware_internal_planning_msgs:srv/SetWaypointRoute.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_internal_planning_msgs/srv/set_waypoint_route.hpp"


#ifndef AUTOWARE_INTERNAL_PLANNING_MSGS__SRV__DETAIL__SET_WAYPOINT_ROUTE__TRAITS_HPP_
#define AUTOWARE_INTERNAL_PLANNING_MSGS__SRV__DETAIL__SET_WAYPOINT_ROUTE__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "autoware_internal_planning_msgs/srv/detail/set_waypoint_route__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'goal_pose'
// Member 'waypoints'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'uuid'
#include "unique_identifier_msgs/msg/detail/uuid__traits.hpp"

namespace autoware_internal_planning_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetWaypointRoute_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: goal_pose
  {
    out << "goal_pose: ";
    to_flow_style_yaml(msg.goal_pose, out);
    out << ", ";
  }

  // member: waypoints
  {
    if (msg.waypoints.size() == 0) {
      out << "waypoints: []";
    } else {
      out << "waypoints: [";
      size_t pending_items = msg.waypoints.size();
      for (auto item : msg.waypoints) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: uuid
  {
    out << "uuid: ";
    to_flow_style_yaml(msg.uuid, out);
    out << ", ";
  }

  // member: allow_modification
  {
    out << "allow_modification: ";
    rosidl_generator_traits::value_to_yaml(msg.allow_modification, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetWaypointRoute_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: goal_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "goal_pose:\n";
    to_block_style_yaml(msg.goal_pose, out, indentation + 2);
  }

  // member: waypoints
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.waypoints.size() == 0) {
      out << "waypoints: []\n";
    } else {
      out << "waypoints:\n";
      for (auto item : msg.waypoints) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: uuid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "uuid:\n";
    to_block_style_yaml(msg.uuid, out, indentation + 2);
  }

  // member: allow_modification
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "allow_modification: ";
    rosidl_generator_traits::value_to_yaml(msg.allow_modification, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetWaypointRoute_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_internal_planning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_internal_planning_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_internal_planning_msgs::srv::SetWaypointRoute_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_internal_planning_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_internal_planning_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_internal_planning_msgs::srv::SetWaypointRoute_Request & msg)
{
  return autoware_internal_planning_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>()
{
  return "autoware_internal_planning_msgs::srv::SetWaypointRoute_Request";
}

template<>
inline const char * name<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>()
{
  return "autoware_internal_planning_msgs/srv/SetWaypointRoute_Request";
}

template<>
struct has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'status'
#include "autoware_common_msgs/msg/detail/response_status__traits.hpp"

namespace autoware_internal_planning_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetWaypointRoute_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: status
  {
    out << "status: ";
    to_flow_style_yaml(msg.status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetWaypointRoute_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status:\n";
    to_block_style_yaml(msg.status, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetWaypointRoute_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_internal_planning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_internal_planning_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_internal_planning_msgs::srv::SetWaypointRoute_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_internal_planning_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_internal_planning_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_internal_planning_msgs::srv::SetWaypointRoute_Response & msg)
{
  return autoware_internal_planning_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>()
{
  return "autoware_internal_planning_msgs::srv::SetWaypointRoute_Response";
}

template<>
inline const char * name<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>()
{
  return "autoware_internal_planning_msgs/srv/SetWaypointRoute_Response";
}

template<>
struct has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>
  : std::integral_constant<bool, has_fixed_size<autoware_common_msgs::msg::ResponseStatus>::value> {};

template<>
struct has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>
  : std::integral_constant<bool, has_bounded_size<autoware_common_msgs::msg::ResponseStatus>::value> {};

template<>
struct is_message<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace autoware_internal_planning_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetWaypointRoute_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetWaypointRoute_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetWaypointRoute_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace autoware_internal_planning_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_internal_planning_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_internal_planning_msgs::srv::SetWaypointRoute_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_internal_planning_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_internal_planning_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const autoware_internal_planning_msgs::srv::SetWaypointRoute_Event & msg)
{
  return autoware_internal_planning_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>()
{
  return "autoware_internal_planning_msgs::srv::SetWaypointRoute_Event";
}

template<>
inline const char * name<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>()
{
  return "autoware_internal_planning_msgs/srv/SetWaypointRoute_Event";
}

template<>
struct has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>
  : std::integral_constant<bool, has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>::value && has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<autoware_internal_planning_msgs::srv::SetWaypointRoute_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<autoware_internal_planning_msgs::srv::SetWaypointRoute>()
{
  return "autoware_internal_planning_msgs::srv::SetWaypointRoute";
}

template<>
inline const char * name<autoware_internal_planning_msgs::srv::SetWaypointRoute>()
{
  return "autoware_internal_planning_msgs/srv/SetWaypointRoute";
}

template<>
struct has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute>
  : std::integral_constant<
    bool,
    has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>::value &&
    has_fixed_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>::value
  >
{
};

template<>
struct has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute>
  : std::integral_constant<
    bool,
    has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>::value &&
    has_bounded_size<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>::value
  >
{
};

template<>
struct is_service<autoware_internal_planning_msgs::srv::SetWaypointRoute>
  : std::true_type
{
};

template<>
struct is_service_request<autoware_internal_planning_msgs::srv::SetWaypointRoute_Request>
  : std::true_type
{
};

template<>
struct is_service_response<autoware_internal_planning_msgs::srv::SetWaypointRoute_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // AUTOWARE_INTERNAL_PLANNING_MSGS__SRV__DETAIL__SET_WAYPOINT_ROUTE__TRAITS_HPP_
